/* SAMPLE EYELINK EXPT FOR WIN32 PLATFORM  */
/*      (c) 1997 by SR Research Ltd.       */
/*      27 November '97 by Dave Stampe     */
/*       For non-commercial use only       */
/*                                         */
/*   This file can serve as a start        */
/*   for programming most experiments      */

/* Windows 95/NT demonstration experiment (C version) */
/* This file: Read a .BMP file and create a bitmap */

/* This module is intended only for private development of experiments       */
/* Use is granted for non-commercial applications by Eyelink licencees only  */

#include <windows.h>
#include <windowsx.h>

#include "eyelink.h"
#include "w32_exptsppt.h"
#include "w32_demo.h"  /* header file for this experiment */


/*********** LOAD BMP FILE, CREATE BITMAP ************/

           // Creates full-screen sized DDB bitmap from loaded .BMP file
           // If <dx, dy> are not 0, will resize image to those dimensions
           // If image won't fill display, clear bitmap to <bgcolor> and centers it
HBITMAP bmp_file_bitmap(char *fname, int dx, int dy, COLORREF bgcolor)
{
  HDC hdc;
  HDC mdc, dmdc;
  HBITMAP hbm;
  HBITMAP hdibm;
  HBITMAP obm, odbm;
  DIBSECTION ds;
  int x=0, y=0;
              
                      // load the BMP file
  hdibm = (HBITMAP)LoadImage(NULL, fname, IMAGE_BITMAP, dx, dy, LR_LOADFROMFILE|LR_CREATEDIBSECTION);
  if(!hdibm) 
    {
      alert_printf("Could not load file '%s'", fname);
      return NULL;
    }
  GetObject(hdibm, sizeof(DIBSECTION), &ds);   // Get information
  if(dx==0 && dy==0)                           // set default size if required
    {
      dx = ds.dsBm.bmWidth;
      if(dx > SCRWIDTH) dx = SCRWIDTH;
      dy = ds.dsBm.bmHeight;
      if(dy > SCRHEIGHT) dy = SCRHEIGHT;
    }
  x = (SCRWIDTH-dx) / 2;      // compute top-left to center bitmap if too small
  y = (SCRHEIGHT-dy) / 2;

  hdc = GetDC(NULL);               
  mdc = CreateCompatibleDC(hdc);    // Create a memory context for BITMAP
  dmdc = CreateCompatibleDC(hdc);   // Create a memory context for DIBSECTION

  hbm = CreateCompatibleBitmap(hdc, SCRWIDTH, SCRHEIGHT);  // Create the BITMAP
  if(!hbm) 
    {
      DeleteObject(hdibm);           // Clean up if failed
      DeleteDC(dmdc);
      DeleteDC(mdc);
      ReleaseDC(NULL, hdc);
      return NULL;
    }
  obm = SelectObject(mdc, hbm);        // select BITMAP
  odbm = SelectBitmap(dmdc, hdibm);    // select DIBSECTION

  if(x>0 || y>0)              // do we need to clear background?
    {
      HBRUSH oBrush = SelectObject(mdc, CreateSolidBrush(bgcolor | 0x02000000L));  // brush to fill with 
      PatBlt(mdc, 0, 0, SCRWIDTH, SCRHEIGHT, PATCOPY);
      DeleteObject(SelectObject(mdc, oBrush));
    }

  StretchBlt(mdc, x, y, dx, dy, dmdc,  // Copy, convert and size DIBSECTION image
             0, 0, ds.dsBm.bmWidth, ds.dsBm.bmHeight, SRCCOPY);

  SelectBitmap(dmdc, odbm);   // Release GDI resources for DIBSECITON context
  DeleteDC(dmdc);
  DeleteObject(hdibm);        // Delete loaded DIBSECTION

  SelectBitmap(mdc, obm);      // Release GDI resources for BITMAP context
  DeleteDC(mdc);
  ReleaseDC(full_screen_window, hdc);

  return hbm;
}
 
